package com.steerinfo.ems.qcmbasechem.controller;

import com.steerinfo.framework.controller.BaseRESTfulController;
import com.steerinfo.framework.controller.RESTfulResult;
import com.steerinfo.framework.service.pagehelper.PageList;
import com.steerinfo.framework.utils.collection.ListUtils;
import com.steerinfo.ems.qcmbasechem.model.QcmBaseChem;
import com.steerinfo.ems.qcmbasechem.service.IQcmBaseChemService;
import io.swagger.annotations.ApiImplicitParam;
import io.swagger.annotations.ApiImplicitParams;
import io.swagger.annotations.ApiOperation;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import java.util.Arrays;
import java.util.HashMap;
import java.util.List;

/**
 * QcmBaseChem RESTful接口：
 * @author generator
 * @version 1.0-SNAPSHORT 2021-12-03 09:10
 * 类描述
 * 修订历史：
 * 日期：2021-12-03
 * 作者：generator
 * 参考：
 * 描述：QcmBaseChem RESTful接口
 * @see null
 * @Copyright 湖南视拓信息技术股份有限公司. All rights reserved.
 */
@RestController
@RequestMapping("/${api.version}/qcmbasechems")
public class QcmBaseChemController extends BaseRESTfulController {

    @Autowired
    IQcmBaseChemService qcmBaseChemService;

    @ApiOperation(value="获取列表", notes="分页查询")
    @ApiImplicitParams({
        @ApiImplicitParam(name = "pageNum", value = "查询页数", required = false, dataType = "Integer"),
        @ApiImplicitParam(name = "pageSize", value = "每页记录数", required = false, dataType = "Integer")
    })
    //@RequiresPermissions("qcmbasechem:view")
    @GetMapping(value = "/")
    public RESTfulResult list(@RequestParam HashMap parmas,Integer pageNum, Integer pageSize){
        PageList<QcmBaseChem> list = qcmBaseChemService.queryForPage(parmas, pageNum, pageSize);
        return success(list);
    }

    @ApiOperation(value="获取列表", notes="分页模糊查询")
    @ApiImplicitParams({
        @ApiImplicitParam(name = "pageNum", value = "查询页数", required = false, dataType = "Integer"),
        @ApiImplicitParam(name = "pageSize", value = "每页记录数", required = false, dataType = "Integer")
    })
    //@RequiresPermissions("qcmbasechem:view")
    @GetMapping(value = "/like/")
    public RESTfulResult listLike(@RequestParam HashMap parmas,Integer pageNum, Integer pageSize){
        PageList<QcmBaseChem> list = qcmBaseChemService.queryLikeForPage(parmas, pageNum, pageSize);
        return success(list);
    }
    
    @ApiOperation(value="创建", notes="根据QcmBaseChem对象创建")
    @ApiImplicitParam(name = "qcmBaseChem", value = "详细实体qcmBaseChem", required = true, dataType = "QcmBaseChem")
    //@RequiresPermissions("qcmbasechem:create")
    @PostMapping(value = "/")
    public RESTfulResult add(@ModelAttribute QcmBaseChem model){
        QcmBaseChem qcmBaseChem = qcmBaseChemService.add(model);
        return success(qcmBaseChem);
    }

    @ApiOperation(value="获取详细信息", notes="根据url的id来获取详细信息")
    @ApiImplicitParam(paramType = "path", name = "id", value = "ID", required = true, dataType = "String")
    //@RequiresPermissions("qcmbasechem:view")
    @GetMapping(value = "/{id}")
    public RESTfulResult get(@PathVariable String id){
        QcmBaseChem qcmBaseChem = qcmBaseChemService.getById(id);
        return success(qcmBaseChem);
    }

    @ApiOperation(value="更新详细信息", notes="根据url的id来指定更新对象，并根据传过来的qcmBaseChem信息来更新详细信息")
    @ApiImplicitParams({
        @ApiImplicitParam(paramType = "path", name = "id", value = "ID", required = true, dataType = "String"),
        @ApiImplicitParam(name = "qcmBaseChem", value = "详细实体qcmBaseChem", required = true, dataType = "QcmBaseChem")
    })
    //@RequiresPermissions("qcmbasechem:update")
    @PutMapping(value = "/{id}", produces  = "application/json;charset=UTF-8")
    public RESTfulResult update(@PathVariable String id, @RequestBody QcmBaseChem model){
        model.setId(id);
        QcmBaseChem qcmBaseChem = qcmBaseChemService.modify(model);
        return success(qcmBaseChem);
    }

    @ApiOperation(value="删除", notes="根据url的id来指定删除对象")
    @ApiImplicitParam(paramType = "path", name = "id", value = "ID", required = true, dataType = "String")
    //@RequiresPermissions("qcmbasechem:delete")
    @DeleteMapping(value = "/{id}")//String
    public RESTfulResult delete(@PathVariable String id){
    	List<String> list = Arrays.asList(id.split(","));
    	if(ListUtils.isNotEmpty(list)) {
	    	List<String> ids = ListUtils.convertList(list);
			  qcmBaseChemService.delete(ids);
    	}
      return success();
    }

    @ApiOperation(value="获取详细信息", notes="根据url的id来获取详细信息")
    @GetMapping("/getIdAndName")
    public RESTfulResult getIdAndName(){
        List<QcmBaseChem> idAndName = qcmBaseChemService.getIdAndName();
        return  success(idAndName);
    }

}
